// Operator Demo
#include <stdio.h>
#include <iostream>
using namespace std;
#include <stdlib.h>

int main(int argc, char* argv[])
{
	// Some simple arrays
	printf("Allocating a one-dimensional and a two-dimensional array\n");
	int a[10];
	int b[]={2,4,19};
//	int c[];	// Syntax error
//	int c[0];	// Syntax error
	printf("\nb[0]=%d\n",b[0]);

	// Multidimensional arrays
	int d[10][10];
	int e[2][3]={{1,2,3},{4,5,6}};
	printf("e[0,2]=%d\n",e[0][2]);

	// Pointers
	printf("\n\nExamples of pointers:\n");
	int i;		// integer variable
	int *iPtr;		// pointer variable (to int)
	iPtr=&i;		// & is the address operator
	printf("\nBefore initialisation (\"int i; int *iPtr;\"):");
	printf("\ni=%d  *iPtr=%d   iPtr=%d (address is %#x in hexadecimal)\n",i,*iPtr,iPtr,iPtr);
	i=5;
	printf("\nAfter \"i=5\":");
	printf("\ni=%d  *iPtr=%d   iPtr=%d (address is %#x in hexadecimal)\n",i,*iPtr,iPtr,iPtr);
	*iPtr=42;
	printf("\nAfter \"*iPtr=42\":");
	printf("\ni=%d  *iPtr=%d   iPtr=%d (address is %#x in hexadecimal)\n",i,*iPtr,iPtr,iPtr);
	int j=*iPtr;
	printf("\nAfter \"int j=*iPtr\":");
	printf("\ni=%d    j=%d    *iPtr=%d   iPtr=%d (address is %#x in hexadecimal)\n",i,j,*iPtr,iPtr,iPtr);
	j=32; iPtr=&j;
	printf("\nAfter \"j=32; iPtr=&j\":");
	printf("\ni=%d    j=%d    *iPtr=%d   iPtr=%d (address is %#x in hexadecimal)\n",i,j,*iPtr,iPtr,iPtr);

	int h[10];
	printf("\n\nRelationship between pointers and arrays:\n");
	printf("\nDefine \"int h[10];\". Then we have:");
	printf("\nh=%#x",h);
	printf("\n&h[0]=%#x Note that h is the address of the first element of the array",&h[0]);
	printf("\n&h[1]=%#x",&h[1]);
	printf("\n&h[2]=%#x  and so on ..\n",&h[2]);

	printf("\nNote that any arithmetic operation performed on a pointer increments the");
	printf("\naddress according to the size of the data type pointed to:");
	printf("\n(h+2)=%#x\n",h+2);
	printf("\n*(h+2) is equivalant to h[2]");

	
	double k[10];
	printf("\n\nNow the same for doubles:\n");
	printf("\nDefine \"double k[10];\". Then we have:");
	printf("\nk=%#x",k);
	printf("\n&k[0]=%#x Note that k is the address of the first element of the array",&k[0]);
	printf("\n&k[1]=%#x",&k[1]);
	printf("\n&k[2]=%#x  and so on ..\n",&k[2]);

	printf("\nThe operation (k+2) increments the address by 2*sizeof(double)=28=16! :");
	printf("\n(k+2)=%#x\n",k+2);
	printf("\n*(k+2) is equivalant to k[2]");


	// Dynamic allocation of an array (C-style)
	printf("\n\nDynamic allocation of arrays:\n");
	printf("\nDynamic allocation of an array (C-Style)! Input array size:");
	int numEntries;
	scanf("%d",&numEntries);
	int *f=(int*) malloc(numEntries*sizeof(int));	// allocate numEntries integers
	for(i=0;i<numEntries;i++) f[i]=i;
	for(i=0;i<numEntries;i++) 
		printf("f[i]=%d\n",f[i]);
	// a more efficient (and nastier looking version) is
	int *g=f;
	while (g!=&f[numEntries]) printf("f[i]=%d\n",*(g++));
	free(f);										// free the allocated memory so that
													// can be used by other parts of the program

	// Dynamic allocation of an array (C++-style)
	cout << "\nDynamic allocation of an array (C++-Style)! Input array size:";
	cin >> numEntries;
	f=new int[numEntries];						// allocate numEntries integers

	for(j=0;j<numEntries;j++) f[j]=j;
	for(j=0;j<numEntries;j++) 
		cout << "f[j]=" << f[j] << "\n";
	delete[] f;									// free the allocated memory so that
												// can be used by other parts of the program
	cout.flush();


	// Strings
	printf("\n\nExamples of strings:\n");
	char s1[11]="Hi!";
	char *s2="Hello";
	printf("\ns1=%s   s2=%s\n",s1,s2);
//	s1="can't do this";
	s1[0]='O'; s1[1]='K'; s1[2]='\0';  
	s2="can do!";
	printf("s1=%s   s2=%s\n",s1,s2);


	return 0;
}
